<div class="email-tracking-style">
    <div class="sticky">
        <h2 class="pb-2 header">
            <span id="user-management-page-heading" jhiTranslate="emailTrackingManagement.home.title">emailTemplateManagement</span>
        </h2>
        <div class="float-left d-flex pb-1 change-item-per-page">
            <div>
                <form name="form" role="form" class="form-inline pb-2" (ngSubmit)="changeItemsPerPage()" [formGroup]="editForm">
                    <div class="d-flex"></div>
                    <div class="form-group">
                        <label class="label-unset-transform pr-1 mr-2" jhiTranslate="emailTrackingManagement.numberItemsPerPage"></label>
                        <input class="form-control mr-2" formControlName="itemPerPage" type="number">
                    </div>
                    <button [disabled]="editForm.invalid" class="btn btn-primary" type="submit" jhiTranslate="emailTrackingManagement.apply">Apply</button>
                </form>
                <div class="justify-content-end" *ngIf="editForm.get('itemPerPage')!.invalid && (editForm.get('itemPerPage')!.dirty || editForm.get('itemPerPage')!.touched)">
                    <small class="form-text text-danger"
                           *ngIf="editForm.get('itemPerPage')?.errors?.required"
                           jhiTranslate="global.messages.validate.itemPerPage.required">
                        Items per page requires max 1000.
                    </small>
                    <small class="form-text text-danger"
                           *ngIf="editForm.get('itemPerPage')?.errors?.max"
                           jhiTranslate="global.messages.validate.itemPerPage.max">
                        Items per page requires max 1000.
                    </small>
                    <small class="form-text text-danger"
                           *ngIf="editForm.get('itemPerPage')?.errors?.min"
                           jhiTranslate="global.messages.validate.itemPerPage.min">
                        Items per page requires min 1.
                    </small>
                </div>
            </div>

            <div class="ml-5">
                <div class="form-inline pb-2" [formGroup]="editForm">
                    <div>
                        <ng-select formControlName="searchOption" style="width: 12rem;"
                                   [items]="searchOptions"
                                   bindLabel="label"
                                   [selectableGroup]="true"
                                   [closeOnSelect]="true"
                                   [clearable]="false"
                                   (change)="changeOption($event)"
                                   [selectableGroupAsModel]="false"
                                   placeholder="{{'cronjobManagement.datePlaceholder' | translate}}"
                                   bindValue="value">
                        </ng-select>
                    </div>
                </div>

            </div>

            <div class="ml-5" *ngIf="editForm.get('searchOption')!.value == 'searchByID'">
                <form name="form" role="form" class="form-inline pb-2" (ngSubmit)="searchByRecipientID()" [formGroup]="editForm">
                    <div class="form-group">
                        <input class="form-control mr-2" formControlName="searchById" type="text">
                    </div>
                    <button [disabled]="editForm.invalid" class="btn btn-primary" type="submit" jhiTranslate="emailTrackingManagement.search">Search</button>
                </form>

                <div class="justify-content-end" *ngIf="editForm.get('searchById')!.invalid && (editForm.get('searchById')!.dirty || editForm.get('searchById')!.touched)">
                    <small class="form-text text-danger"
                           *ngIf="editForm.get('searchById')?.errors?.pattern"
                           jhiTranslate="global.messages.validate.numberRequire">
                    </small>
                </div>
            </div>

            <div class="ml-5" *ngIf="editForm.get('searchOption')!.value == 'freeSearch'">
                <form name="form" role="form" class="form-inline pb-2" (ngSubmit)="search()" [formGroup]="editForm">
                    <div class="form-group">
                        <input class="form-control mr-2" formControlName="search" type="text">
                    </div>
                    <button [disabled]="editForm.invalid" class="btn btn-primary" type="submit" jhiTranslate="emailTrackingManagement.search">Search</button>
                </form>
            </div>
        </div>
        <div ngbDropdown class="float-right pb-1">
            <button [disabled]="this.selectedEmailTrackings.length === 0" ngbDropdownToggle class="btn btn-primary">
                <span jhiTranslate="entity.action.action">Action</span>
                <ul class="dropdown-menu" ngbDropdownMenu >
                    <li *ngFor="let status of statusList">
                        <a class="dropdown-item drop-item-action" (click)="changeStatusOfSeveralEmailTrackings(status.value)">
                            <span>{{status.content | translate}}</span>
                        </a>
                    </li>
                </ul>
            </button>
        </div>
        <div class="row w-100 text-center">
            <div class="w-100 alert alert-secondary" role="alert" *ngIf="emailTrackingList && emailTrackingList.length === 0">
                <span jhiTranslate="global.dataEmpty"> recipientLists are empty! </span>
            </div>
        </div>
    </div>
    <div class="table-responsive border-table"  *ngIf="emailTrackingList && emailTrackingList.length > 0">
        <table class="table table-striped mb-0" aria-describedby="user-management-page-heading">
            <thead class="thead-light">
                <tr jhiSort [(predicate)]="predicate" [(ascending)]="ascending" [callback]="transition.bind(this)">
                    <th scope="col"><input type="checkbox" (change)="markAll(!selectAll)"></th>
                    <th scope="col" jhiSortBy="recipient_id"><span jhiTranslate="emailTrackingManagement.procurementId">ID</span> <fa-icon icon="sort"></fa-icon></th>
                    <th scope="col" jhiSortBy="cronJob_id"><span jhiTranslate="emailTrackingManagement.cronjob"></span> <fa-icon icon="sort"></fa-icon></th>
                    <th scope="col" jhiSortBy="status" class="text-center"> <span jhiTranslate="emailTrackingManagement.status">status</span><fa-icon icon="sort"></fa-icon></th>
                    <th scope="col" jhiSortBy="recipient_county"><span jhiTranslate="emailTrackingManagement.county"></span><fa-icon icon="sort"></fa-icon></th>
                    <th scope="col" jhiSortBy="recipient_title"><span jhiTranslate="emailTrackingManagement.procurement"></span> <fa-icon icon="sort"></fa-icon></th>
                    <th scope="col" jhiSortBy="recipient_referenceNumber"><span jhiTranslate="emailTrackingManagement.refnr"></span> <fa-icon icon="sort"></fa-icon></th>
                    <th scope="col" jhiSortBy="recipient_procuringAgency"><span jhiTranslate="emailTrackingManagement.authority"></span> <fa-icon icon="sort"></fa-icon></th>
                    <th scope="col" jhiSortBy="registrar"> <span jhiTranslate="emailTrackingManagement.registrar"></span><fa-icon icon="sort"></fa-icon></th>
                    <th scope="col" jhiSortBy="recipient_email"> <span jhiTranslate="emailTrackingManagement.purchaser"></span><fa-icon icon="sort"></fa-icon></th>
                    <th scope="col" jhiSortBy="recipient_procurementUrl"> <span jhiTranslate="emailTrackingManagement.procurementURL"></span><fa-icon icon="sort"></fa-icon></th>
                    <th scope="col" jhiSortBy="createdDate"> <span jhiTranslate="emailTrackingManagement.requestDate"></span><fa-icon icon="sort"></fa-icon></th>
                    <th scope="col" jhiSortBy="reminderDate1"> <span jhiTranslate="emailTrackingManagement.remindDate1"></span><fa-icon icon="sort"></fa-icon></th>
                    <th scope="col" jhiSortBy="reminderDate2"> <span jhiTranslate="emailTrackingManagement.remindDate2"></span><fa-icon icon="sort"></fa-icon></th>
                    <th scope="col"></th>
                </tr>
            </thead>
            <tbody *ngIf="emailTrackingList">
                <tr *ngFor="let emailTracking of emailTrackingList;">
                    <td> <input type="checkbox" [(ngModel)]="emailTracking.isSelected" (change)="markAnEmailTracking(emailTracking)"></td>
                    <td>{{ emailTracking.recipient?.id }}</td>
                    <td>{{ emailTracking.cronJob?.id }}</td>
                    <td class="text-center" ngbDropdown container="body">
                        <span [ngbTooltip]="getToolTipByStatus(emailTracking.status!) | translate" class="status cursor-email-status" [ngClass]="getClassByStatus(emailTracking.status!)" ngbDropdownToggle>  {{emailTracking.status! | emailStatus | translate}}
                            <ul  class="dropdown-menu" ngbDropdownMenu>
                                <li *ngFor="let status of statusList">
                                    <a *ngIf="status.value !== emailTracking.status" class="dropdown-item" (click)="changeStatus(status.value, emailTracking)">
                                        <span>{{ status.content | translate }}</span>
                                    </a>
                                </li>
                            </ul>
                        </span>
                        <div class="mt-1" *ngIf="emailTracking.status ==='COULD_NOT_BE_SENT'">
                            <a jhiTranslate="entity.action.resend" class="resend-button" (click)="showResend(emailTracking.id!)"></a>
                        </div>
                    </td>
                    <td>{{ emailTracking.recipient?.county }}</td>
                    <td>{{ emailTracking.recipient?.title }}</td>
                    <td>{{ emailTracking.recipient?.referenceNumber }}</td>
                    <td>{{ emailTracking.recipient?.procuringAgency }}</td>
                    <td>{{ emailTracking.registrar }}</td>
                    <td>{{ emailTracking.recipient?.email }}</td>
                    <td><button class="btn-primary btn" (click)="openUrlDialog(emailTracking.recipient?.procurementUrl!)">Show Url</button></td>
                    <td>{{ emailTracking.createdDate | date: 'dd/MM/yyyy' }}</td>
                    <td [ngClass]="emailTracking.sentReminder1 ? 'text-danger' : ''"><span [ngbTooltip]="emailTracking.sentReminder1 ? ('emailTrackingManagement.sent' | translate) : ''">{{ emailTracking.reminderDate1 | date: 'dd/MM/yyyy' }} </span></td>
                    <td [ngClass]="emailTracking.sentReminder2 ? 'text-danger' : ''"><span [ngbTooltip]="emailTracking.sentReminder2 ? ('emailTrackingManagement.sent' | translate) : ''">{{ emailTracking.reminderDate2 | date: 'dd/MM/yyyy' }} </span></td>
                    <td class="text-right">
                        <div class="btn-group">
                            <button ngbTooltip="{{'entity.action.comment' | translate}}" class="btn custom-icon-btn" type="button" (click)="openCommentDialog(emailTracking.id!)">
                                <i class="bi bi-chat-text"></i>
                            </button>
                            <button ngbTooltip="{{'entity.action.edit' | translate}}" class="btn custom-icon-btn" type="button" [routerLink]="['./', emailTracking.id, 'edit']"  [queryParams]="{from: page}">
                                <i class="bi bi-pencil"></i>
                            </button>
                            <button ngbTooltip="{{'entity.action.archive' | translate}}" class="btn custom-icon-btn" type="button" (click)="archive(emailTracking.id!, emailTracking?.recipient!.id!)">
                                <i class="bi bi-archive"></i>
                            </button>
                        </div>
                    </td>
                </tr>
            </tbody>
        </table>
    </div>

    <div *ngIf="emailTrackingList" class="pt-5 d-flex justify-content-end mr-0">
        <jhi-item-count class="mr-4 align-self-center" [page]="page" [total]="totalItems" [itemsPerPage]="itemsPerPage"></jhi-item-count>
        <ngb-pagination *ngIf="totalItems" size="sm" [collectionSize]="totalItems" [(page)]="page" [pageSize]="itemsPerPage" [maxSize]="3" [rotate]="true" [boundaryLinks]="true" (pageChange)="transition()"></ngb-pagination>
    </div>
</div>
